{{define "head"}}<title>Robots</title>{{end}}
{{define "body"}}

    <div>
        <input type="text" id="userIDInput" placeholder="user id"/>
        <input type="text" id="tickerInput" placeholder="ticker"/>
        <button type="button" onclick="setParams()">search</button>
    </div><br/>

    <div>

        <table border="1" id="robots">
            <thead>
            <tr>
                <th id="robotID">Robot ID</th>
                <th id="userID">User ID</th>
                <th id="ticker">Ticker</th>
                <th id="isActive">Is active</th>
                <th id="dealsCount">Deals count</th>
                <th id="factYield">Fact yield</th>
                <th id="favorite">Is favorite</th>
                <th id="planStart">Plan start</th>
                <th id="planEnd">Plan end</th>
            </tr>
            </thead>
            <tbody id="robotTableBody"></tbody>
        </table>
    </div>

    <script type="text/javascript">
        let urlParams = new URLSearchParams(window.location.search)
        let userID = urlParams.get("user");
        let ticker = urlParams.get("ticker");

        document.getElementById("userIDInput").value = userID
        document.getElementById("tickerInput").value = ticker

        let wsString = "ws://localhost:8080/api/v1/robots/ws" + `?${userID != null ? `user=${userID}` : ""}&${ticker != null ? `ticker=${ticker}` : ""}`
        let ws = new WebSocket(wsString)
        ws.onopen = function () {
            console.log("WS is open")
        }

        ws.onclose = function () {
            console.log("WS is close")
        }

        let map = new Map()

        ws.onmessage = function (event) {
            console.log("receive ws message")

            let tbody = document.getElementById("robotTableBody");
            tbody.innerHTML = ""

            let parsedJson = JSON.parse(event.data.toString());

            if (parsedJson instanceof Array) {
                parsedJson.forEach(element => {
                    map.set(element.robot_id, element)
                })
            } else {
                map.set(parsedJson.robot_id, parsedJson)
            }

            map.forEach(element => {
                let row = tbody.insertRow(tbody.rows.length);
                printRow(row, element);
            })
        }

        function printRow(row, json) {
            row.insertCell(0).innerText = json.robot_id;
            row.insertCell(1).innerText = json.owner_user_id;
            row.insertCell(2).innerText = json.ticker;
            row.insertCell(3).innerText = json.is_active;
            row.insertCell(4).innerText = json.deals_count;
            row.insertCell(5).innerText = json.fact_yield;
            row.insertCell(6).innerText = json.is_favorite;
            row.insertCell(7).innerText = json.plan_start;
            row.insertCell(8).innerText = json.plan_end;

            row.insertCell(9).innerHTML = `<button onclick="activateRobot(${json.robot_id})">activate</button>`
            row.insertCell(10).innerHTML = `<button onclick="deactivateRobot(${json.robot_id})">deactivate</button>`
            row.insertCell(11).innerHTML = `<button onclick="addFavorite(${json.robot_id})">favorite</button>`

        }

        function activateRobot(robotID) {
            let request = new XMLHttpRequest();
            request.open("PUT", `http://localhost:8080/api/v1/robot/${robotID}/activate`)
            request.send()
        }

        function deactivateRobot(robotID) {
            let request = new XMLHttpRequest();
            request.open("PUT", `http://localhost:8080/api/v1/robot/${robotID}/deactivate`)
            request.send()
        }

        function addFavorite(robotID) {
            let request = new XMLHttpRequest();
            request.open("PUT", `http://localhost:8080/api/v1/robot/${robotID}/favorite`)
            request.send()
        }

        function setParams() {
            let userID = document.getElementById("userIDInput").value.trim();
            let ticker = document.getElementById("tickerInput").value.trim();

            let url = "/api/v1/robots"
            if (userID != null && userID !== "") {
                url += `?user=${userID}`
            }

            if (ticker != null && ticker !== "") {
                if (userID != null && userID !== "") {
                    url += `&ticker=${ticker}`
                } else {
                    url += `?ticker=${ticker}`
                }
            }

            location.href = url
        }

    </script>

{{end}}
